#include "3d.h"
#include "model.h"

#define eps 0.01

char	w[maxpol][maxpol];
int	nbpn,nbsg,nbpl;
int	compl;

int preparetra()
	{
		int	i,j,k;

	for(i=0;i<nbpntsource;i++)
		{
		bufpnt[i].p=sourcepnt[i];
		bufpnt[i].state=0;
		}
	nbpn=nbpntsource;

	for(i=0;i<nbsegsource;i++)
		{
		bufseg[i]=sourceseg[i];
		}
	nbsg=nbsegsource;

	for(i=0;i<nbpolsource;i++)
		{
		bufpol[i].type=sourcepol[i].type;
		bufpol[i].col=sourcepol[i].col;

		if (sourcepol[i].ns==1)
			{
			bufpol[i].np=2;
			bufpol[i].pn[0]=bufseg[sourcepol[i].nums[0]&0x7fff].n1;
			bufpol[i].pn[1]=bufseg[sourcepol[i].nums[0]&0x7fff].n2;
			return -1;
			}
		if (sourcepol[i].ns==3)
			{
			bufpol[i].np=3;
			for(j=0;j<3;j++)
			  {
			  k=sourcepol[i].nums[j];
			  if (k&0x8000) bufpol[i].pn[j]=bufseg[k&0x7fff].n2;
				else	bufpol[i].pn[j]=bufseg[k].n1;
			  }
			vnorm(&sourcepnt[bufpol[i].pn[0]]
				,&sourcepnt[bufpol[i].pn[1]]
				,&sourcepnt[bufpol[i].pn[2]]
				,&bufpol[i].norm);
			}
		bufpol[i].frere=i-1;
		}
	nbpl=nbpolsource;

	return nbpl-1;
	}

void creatmat(int l)
	{
		int	i,j,k;
		float	f;
		pntw	p,q;
		polw	z,zz;
		int	np,nn,st;

	i=l;
	while(i!=-1)
	  {
	  z=&bufpol[i];
	  for(k=0;k<nbpn;k++)
		{
		p=&bufpnt[k];
		q=&bufpnt[z->pn[0]];
		f=(p->p.x-q->p.x)*z->norm.xv + (p->p.y-q->p.y)*z->norm.yv 
			+ (p->p.z-q->p.z)*z->norm.zv ;
		if (f>eps) p->state=1;
			else if (f<-eps) p->state=-1;
				else p->state=0;
		}
	  j=l;
	  while(j!=-1)
		{
		zz=&bufpol[j];
		if (j==i) w[i][j]=-1;
			else
			{
			nn=np=0;
			for(k=0;k<3;k++)
				{
				st=bufpnt[zz->pn[k]].state;
				if (st==1) np++;
					else if (st==0) nn++;
				}
			if (np) w[i][j]=np+nn;
				else if (nn==3) w[i][j]=-1;
					else w[i][j]=np;
			}
		j=zz->frere;
		}
	  i=z->frere;
	  }
	}

int createpol(int p, int *pl, int k, int last, int md)
	{
		int	i;
		polw	b;

	if (md==-1) md=nbpl++;
	i=1;
	while(i)
		{
		i=0;
		b=&bufpol[md];
		b->type=bufpol[last].type;
		b->col=bufpol[last].col;
		b->frere=p;
		p=md;
		b->np=3;
		b->pn[0]=pl[0];
		b->pn[1]=pl[1];
		b->pn[2]=pl[2];
		vnorm(&bufpnt[pl[0]].p,&bufpnt[pl[1]].p
				,&bufpnt[pl[2]].p,&b->norm);
		if (k>3)	{
				k=3;
				i=1;
				pl[1]=pl[3];
				md=nbpl++;
				}
		}
	return p;
	}
		

int ppp;
int qqq;

void coupe(int b, int i, int pp, int qq)
	{
		int	a[4];
		float	sc[4];
		float	l;
		int	j,k;
		pnt	f,g,h,np;
		polw	y,z;
		vec	v;
		int	ppl[6],pmn[6];
		int	kpl,kmn;

	y=&bufpol[b];
	z=&bufpol[i];
	f=&bufpnt[y->pn[0]].p;
	v=&y->norm;

	for(j=0;j<3;j++)
		{
		a[j]=z->pn[j];
		g=&bufpnt[a[j]].p;
		sc[j]=(g->x-f->x)*v->xv + (g->y-f->y)*v->yv + (g->z-f->z)*v->zv;
		}
	a[3]=a[0];
	sc[3]=sc[0];
	kpl=kmn=0;
	for(j=0;j<3;j++)
		{
		if (sc[j]>-eps) ppl[kpl++]=a[j];
		if (sc[j]<eps) pmn[kmn++]=a[j];
		if ( ((sc[j]>eps)&&(sc[j+1]<-eps))
			|| ((sc[j]<-eps)&&(sc[j+1]>eps)) )
			{
			g=&bufpnt[a[j]].p;
			h=&bufpnt[a[j+1]].p;
			np=&bufpnt[nbpn].p;
			l=sc[j]/(sc[j]-sc[j+1]);
			np->x=g->x+l*(h->x-g->x);
			np->y=g->y+l*(h->y-g->y);
			np->z=g->z+l*(h->z-g->z);
			ppl[kpl++]=nbpn;
			pmn[kmn++]=nbpn;
			nbpn++;
			}
		}
	qqq=createpol(qq,ppl,kpl,i,i);
	ppp=createpol(pp,pmn,kmn,i,-1);
	}

			



void afmat()
	{
		int	i,j;

	for(i=0;i<nbpl;i++)
		{
		for(j=0;j<nbpl;j++)
			printf("%d ",w[i][j]);
		printf("\n");
		}
	}

void aflist(int l)
	{
	while(l!=-1)
		{
		printf("%d ",l);
		l=bufpol[l].frere;
		}
	printf("\n");
	}

int comprec(int l)
	{
		int	n=nbnoeud;
		int	p,q,pp,qq;
		int	i,in,j,s,k,a,b;
		polw	z;
		pnt	x;

	if (l==-1) return -1;
/*	printf("noeud %d\n",n);	*/
	nbnoeud++;
	creatmat(l);
/*	afmat();	*/
/*	printf("recherche de l'enveloppe\n");	*/
	p=q=-1;
	i=l;
	while(i!=-1)
		{
		z=&bufpol[i];
		in=z->frere;
		j=i;
		s=-1;
		a=0;
		while((j!=-1)&&(s!=1))
			{
			switch (w[i][j]) {
			case -2:
				break;
			case -1:
				break;
			case 0 :
				if (s==3) s=1;
					else s=0;
				break;
			case 3 :
				if (s==0) s=1;
					else s=3;
				break;
			default:
				s=1;
				break;	}
			j=bufpol[j].frere;
			if (j==-1)
				{
				a++;
				if (a==1)
					{
					j=p;
					if (j==-1) a++;
					}
				if (a==2) j=q;
				}
			}
/*		printf("s[%d]=%d\n",i,s);	*/
		if (s==1)
			{
			z->frere=q;
			q=i;
			}
			else
			{
			z->frere=p;
			p=i;
			if (s==0)	{
					k=z->pn[1];
					z->pn[1]=z->pn[2];
					z->pn[2]=k;
					z->norm.xv=-z->norm.xv;
					z->norm.yv=-z->norm.yv;
					z->norm.zv=-z->norm.zv;
					}
			}
		i=in;
		}
/*	aflist(p);	*/
/*	aflist(q);	*/
	noeuds[n].firstp=p;
	if (q==-1)	{
			noeuds[n].filsp=noeuds[n].filsm=-1;
			return n;
			}
	if (p!=-1)	{
			noeuds[n].filsm=-1;
			noeuds[n].filsp=comprec(q);
			return n;
			}
	a=nbpl;
	i=b=q;
	while(i!=-1)
		{
		k=0;
		j=q;
		while(j!=-1)
			{
			s=w[i][j];
			if ((s==1)||(s==2)) k++;
			j=bufpol[j].frere;
			}
		if (k<a)	{
				a=k;
				b=i;
				}
		i=bufpol[i].frere;
		}

/*	printf("couper par %d\n",b);	*/
	compl++;
	pp=qq=-1;
	i=q;
	while(i!=-1)
		{
		in=bufpol[i].frere;
		s=w[b][i];
		if (s==3)	{
				bufpol[i].frere=qq;
				qq=i;
				}
		else	{
			if (s<1)
				{
				bufpol[i].frere=pp;
				pp=i;
				}
			else 	{
				coupe(b,i,pp,qq);
				pp=ppp;
				qq=qqq;
				}
			}
		i=in;
		}
/*	aflist(pp);	*/
/*	aflist(qq);	*/

	z=&bufpol[b];
	x=&bufpnt[z->pn[0]].p;
	noeuds[n].firstp=-1;
	noeuds[n].a=z->norm.xv;
	noeuds[n].b=z->norm.yv;
	noeuds[n].c=z->norm.zv;
	noeuds[n].d=-(x->x*z->norm.xv + x->y*z->norm.yv + x->z*z->norm.zv);
	noeuds[n].filsp=comprec(pp);
	noeuds[n].filsm=comprec(qq);
	return n;
	
	}

int reintegre()
	{
	int	i;

	videpile();
	nbpntsource=nbpn;  
	for(i=0;i<nbpntsource;i++)
		sourcepnt[i]=bufpnt[i].p;

	nbsegsource=0;
	nbpolsource=nbpl;
	for(i=0;i<nbpolsource;i++)
		{
		sourcepol[i].type=bufpol[i].type;
		sourcepol[i].col=bufpol[i].col;
		sourcepol[i].frere=bufpol[i].frere;
		if(bufpol[i].np==2)
			{
			sourcepol[i].ns=1;
			sourcepol[i].nums[0]=ajouteseg(bufpol[i].pn[0]
							,bufpol[i].pn[1]);
			}
		if(bufpol[i].np==3)
			{
			sourcepol[i].ns=3;
			sourcepol[i].nums[0]=ajouteseg(bufpol[i].pn[0]
							,bufpol[i].pn[1]);
			sourcepol[i].nums[1]=ajouteseg(bufpol[i].pn[1]
							,bufpol[i].pn[2]);
			sourcepol[i].nums[2]=ajouteseg(bufpol[i].pn[2]
							,bufpol[i].pn[0]);
			sourcepol[i].norm=bufpol[i].norm;
			}
		}

	return 1;

	}


int compil()
	{
		int	l;

	compl=0;
	nbnoeud=0;
	printf("preparation des donnees\n");
	l=preparetra();
	if (l<0)
		{
		printf("compilation impossible\n");
		return 1;
		}
	printf("compilation de l'objet\n");
	comprec(l);
	printf("mise a jour\n");
	reintegre();
	printf("complexite : %d\n",compl);
	printf("ok\n");
	return 0;
	}




