#include "3d.h"
#include "model.h"

struct Pnt	copypnt[maxpnt];
struct Seg	copyseg[maxseg];
struct Pol	copypol[maxpol];
int	nbpnc;
int	nbsgc;
int	nbplc;

int	ind;
int	col;

void videpile()
	{
	ind=-1;
	}

void inimodel()
	{
	videpile();
	nbpntsource=0;
	nbsegsource=0;
	nbpolsource=0;
	nbnoeud=0;
	col=0;
	}

void empile(int	p)
	{
	depilep(p);
	sourcepnt[p].nxtp=ind;
	ind=p;
	}

void empileall()
	{
		int	i;

	for(i=0;i<nbpntsource;i++)
		empile(i);
	}

int depile()
	{
		int	i=ind;

	if (ind!=-1) ind=sourcepnt[ind].nxtp;
	return i;
	}

void depilep(int p)
	{
		int	i,j;

	i=-1;
	j=ind;
	while(j!=-1)
		{
		if (j==p)
			{
			if (i!=-1) sourcepnt[i].nxtp=sourcepnt[j].nxtp;
				else ind=sourcepnt[j].nxtp;
			}
			else	i=j;
		j=sourcepnt[j].nxtp;
		}
	}

void newpnt(unsigned int s)
	{
		int	k;

	if (s)	{
		k=ind;
		ind=-1;
		while(k!=-1)
			{
			sourcepnt[nbpntsource].x=sourcepnt[k].x+1.0;
			sourcepnt[nbpntsource].y=sourcepnt[k].y+1.0;
			sourcepnt[nbpntsource].z=sourcepnt[k].z+1.0;
			empile(nbpntsource++);
			k=sourcepnt[k].nxtp;
			}
		}
	else	{
		if (ind!=-1)
			{
			sourcepnt[nbpntsource].x=sourcepnt[ind].x+1.0;
			sourcepnt[nbpntsource].y=sourcepnt[ind].y+1.0;
			sourcepnt[nbpntsource].z=sourcepnt[ind].z+1.0;
			}
			else
			{
			sourcepnt[nbpntsource].x=0.0;
			sourcepnt[nbpntsource].y=0.0;
			sourcepnt[nbpntsource].z=0.0;
			}
		empile(nbpntsource++);
		}
	nbnoeud=0;
	}

int newseg(int p, int q)
	{
		int	i;

	nbnoeud=0;
	for(i=0;i<nbsegsource;i++)
		{
		if ((sourceseg[i].n1==p)&&(sourceseg[i].n2==q)) return i;
		if ((sourceseg[i].n1==q)&&(sourceseg[i].n2==p)) return i+0x8000;
		}
	sourceseg[nbsegsource].n1=p;
	sourceseg[nbsegsource].n2=q;
	nbsegsource++;
	return nbsegsource-1;
	}

void newpol()
	{
		int	i,n[3];

	nbnoeud=0;
	i=0;
	while((i<3)&&(ind!=-1))
		n[i++]=depile();

	printf("%d\n",i);
	if (i==3)	{
			printf("a\n");
			sourcepol[nbpolsource].type=0;
			sourcepol[nbpolsource].col=col;
			sourcepol[nbpolsource].frere=-1;
			sourcepol[nbpolsource].ns=i;
			sourcepol[nbpolsource].nums[0]=newseg(n[0],n[1]);
			sourcepol[nbpolsource].nums[1]=newseg(n[1],n[2]);
			sourcepol[nbpolsource].nums[2]=newseg(n[2],n[0]);
			nbpolsource++;
			}
	if (i==2)	{
			printf("*\n");
			sourcepol[nbpolsource].type=0;
			sourcepol[nbpolsource].col=col;
			sourcepol[nbpolsource].frere=-1;
			sourcepol[nbpolsource].ns=1;
			sourcepol[nbpolsource].nums[0]=newseg(n[0],n[1]);
			nbpolsource++;
			}
	}

int effseg(int s)
	{
		int	i,j;

	nbnoeud=0;
	for(i=0;i<nbpolsource;i++)
		for(j=0;j<sourcepol[i].ns;j++)
			if((sourcepol[i].nums[j]&0x7fff)==s) return 0;
	for(i=0;i<nbpolsource;i++)
		for(j=0;j<sourcepol[i].ns;j++)
			if((sourcepol[i].nums[j]&0x7fff)>s)
					sourcepol[i].nums[j]--;
	for(i=s;i<nbsegsource-1;i++)
		sourceseg[i]=sourceseg[i+1];
	nbsegsource--;
	return -1;
	}

void killpol(int p)
	{
		int	i,j;
		int	k,n[3];

	nbnoeud=0;
	k=sourcepol[p].ns;
	for(i=0;i<k;i++)
		n[i]=sourcepol[p].nums[i]&0x7fff;
	for(i=p;i<nbpolsource-1;i++)
		sourcepol[i]=sourcepol[i+1];
	nbpolsource--;

	for(i=0;i<k;i++)
		if (effseg(n[i])==-1)
			for(j=i+1;j<k;j++)
				if (n[j]>n[i]) n[j]--;
	}

void killpnt(int p)
	{
		int	i,j,k,s;

	nbnoeud=0;
	depilep(p);

	for(i=0;i<nbpolsource;i++)
		{
		s=0;
		for(j=0;j<sourcepol[i].ns;j++)
			{
			k=sourcepol[i].nums[j]&0x7fff;
			if ((sourceseg[k].n1==p)||(sourceseg[k].n2==p)) s=1;
			}
		if (s) killpol(i--);
		}

	for(i=0;i<nbsegsource;i++)
		{
		if (sourceseg[i].n1>p) sourceseg[i].n1--;
		if (sourceseg[i].n2>p) sourceseg[i].n2--;
		}

	for(i=0;i<nbpntsource;i++)
		{
		if (sourcepnt[i].nxtp>p) sourcepnt[i].nxtp--;
		if (i>p) sourcepnt[i-1]=sourcepnt[i];
		}
	if (ind>p) ind--;
	nbpntsource--;
	}

void effpnt(unsigned int state)
	{
	nbnoeud=0;
	do	{
		if (ind!=-1) killpnt(ind);
		}
	while((ind!=-1)&&(state&ShiftMask));
	}

void effpol()
	{
		int	i,j,k,l,s,t,a,n[3];

	nbnoeud=0;
	i=0;
	while((i<3)&&(ind!=-1))
		n[i++]=depile();

	for(j=0;j<nbpolsource;j++)
		{
		s=0;
		for(l=0;l<i;l++)
			{
			t=0;
			for(k=0;k<sourcepol[j].ns;k++)
				{
				a=sourcepol[j].nums[k]&0x7fff;
				if ((sourceseg[a].n1==n[l])
					||(sourceseg[a].n2==n[l])) t=1;
				}
			if (t) s++;
			}
		if (s==i) killpol(j--);
		}
	}

int findnear(float x, float y)
	{
		int	i;
		float	a;
		int	r=-1+4;
		float	k=10000;

	for(i=4;i<nbpntsource+4;i++)
		if ((bufpnt[i].state==0)
			&&((a=abs(bufpnt[i].xp-x)+abs(bufpnt[i].yp-y))<k))
					{ k=a; r=i; }
	return r-4;
	}


void afcoord(float x, float y, float z)
	{
		char	c[100];

	sprintf(c,"x = %f    ",x);
	XDrawImageString(display,tools,gc,5,335,c,strlen(c));
	sprintf(c,"y = %f    ",y);
	XDrawImageString(display,tools,gc,5,350,c,strlen(c));
	sprintf(c,"z = %f    ",z);
	XDrawImageString(display,tools,gc,5,365,c,strlen(c));
	}

void afvide()
	{
		char	c[100];

	sprintf(c,"x =              ");
	XDrawImageString(display,tools,gc,5,335,c,strlen(c));
	sprintf(c,"y =              ");
	XDrawImageString(display,tools,gc,5,350,c,strlen(c));
	sprintf(c,"z =              ");
	XDrawImageString(display,tools,gc,5,365,c,strlen(c));
	}

void afcourant()
	{
		int	i;

	XSetForeground(display,gc,white);
	XSetBackground(display,gc,black);

	if (ind!=-1)
		afcoord(sourcepnt[ind].x,sourcepnt[ind].y,sourcepnt[ind].z);
		else
		afvide();
	}

void afpara()
	{
	printf("\nnb pnt     : %d\nnb seg     : %d\nnb pol     : %d\n"
			,nbpntsource,nbsegsource,nbpolsource);
	printf("nb noeuds  : %d\n",nbnoeud);
	}


void afcroix(observ obs, float x, float y, int type)
	{
	if (type==0)	
		{
		XDrawLine(obs->display,obs->dessin,obs->gc,x-4,y,x+4,y);
		XDrawLine(obs->display,obs->dessin,obs->gc,x,y-4,x,y+4);
		}
	if (type==1)	
		{
		XDrawLine(obs->display,obs->dessin,obs->gc,x-4,y-4,x+4,y+4);
		XDrawLine(obs->display,obs->dessin,obs->gc,x+4,y-4,x-4,y+4);
		}
	if (type==2)	
		{
		XDrawLine(obs->display,obs->dessin,obs->gc,x-6,y-6,x+6,y+6);
		XDrawLine(obs->display,obs->dessin,obs->gc,x+6,y-6,x-6,y+6);
		}
	}

void ajoutecroix(observ obs)
	{
		int	i,j;

	XSetForeground(display,gc,white);
	for(i=4;i<nbpntsource+4;i++)
		if (bufpnt[i].state==0)
			afcroix(obs,obs->sx+bufpnt[i].xp
				,obs->sy-bufpnt[i].yp,0);
	j=ind;
	i=2;
	while(j!=-1)
		{
		if (bufpnt[j+4].state==0)
			afcroix(obs,obs->sx+bufpnt[j+4].xp
					,obs->sy-bufpnt[j+4].yp,i);
		j=sourcepnt[j].nxtp;
		i=1;
		}
	}

void afcr(Window win, GC gc, float x, float y, int i)
	{
	XDrawLine(display,win,gc,x-4,y,x+4,y);
	XDrawLine(display,win,gc,x,y-4,x,y+4);
	if (i==0)
		{
		XDrawLine(display,win,gc,x-4,y-4,x+4,y+4);
		XDrawLine(display,win,gc,x+4,y-4,x-4,y+4);
		}
	}

XPoint	flech[]={0,40*7+15,15,0,0,-5,15,10,-15,10,0,-5,-15,0,0,-10};
XPoint	tria1[]={25,40*6+5,-5,30,25,-5,-20,-25};
XPoint	tria2[]={50,40*6+10,5,15,-45,0,40,-15};
void affichetools()
	{
		int	i;

	XSetForeground(display,gc,white);
	XSetBackground(display,gc,black);
	XDrawLine(display,tools,gc,64,0,64,320);
	for(i=40;i<321;i+=40)
		XDrawLine(display,tools,gc,0,i,128,i);

	for(i=0;i<2;i++)
		{
		XDrawArc(display,tools,gc,i*64+27,15,10,10,0,64*360);
		XDrawLine(display,tools,gc,i*64+25,45,i*64+15,75);
		XDrawLine(display,tools,gc,i*64+25,45,i*64+49,65);
		XDrawLine(display,tools,gc,i*64+49,65,i*64+15,75);
		}
	for(i=0;i<2;i++)
		{
		XDrawLine(display,tools,gc,64+5,i*40+5,128-5,i*40+35);
		XDrawLine(display,tools,gc,64+5,i*40+35,128-5,i*40+5);
		}
	for(i=0;i<2;i++)
		{
		afcr(tools,gc,64*i+24,80+12,i);
		afcr(tools,gc,64*i+48,80+10,i);
		afcr(tools,gc,64*i+16,80+30,i);
		afcr(tools,gc,64*i+35,80+25,i);
		}
	XDrawImageString(display,tools,gc,15,40*3+25,"x,y,z",5);

	XDrawPoint(display,tools,gc,24,160+12);
	XDrawPoint(display,tools,gc,48,160+10);
	XDrawPoint(display,tools,gc,16,160+30);
	XDrawPoint(display,tools,gc,35,160+25);



	XDrawLines(display,tools,gc,tria1,4,CoordModePrevious);
	XSetForeground(display,gc,black);
	XFillPolygon(display,tools,gc,tria2,4,Complex,CoordModePrevious);
	XSetForeground(display,gc,white);
	XDrawLines(display,tools,gc,tria2,4,CoordModePrevious);

	XDrawRectangle(display,tools,gc,64+16,240+8,32,24);
	XDrawRectangle(display,tools,gc,64+40,240+8,8,6);
	XDrawArc(display,tools,gc,64+24,240+12,16,16,0,64*360);
	XDrawArc(display,tools,gc,64+26,240+14,12,12,0,64*360);
	
	

	for(i=0;i<2;i++)
		{
		XDrawRectangle(display,tools,gc,64*i+17,40*7+5,30,30);
		XDrawRectangle(display,tools,gc,64*i+25,40*7+5,14,15);
		flech[0].x=5+i*88;
		XDrawLines(display,tools,gc,flech,8,CoordModePrevious);
		}

	afcourant();
	if (modegraph==0)
		{
		XSetState(display,gc,pixels[col*32+24],0,GXcopy,AllPlanes);
		XFillRectangle(display,tools,gc,65,40*3+1,63,39);
		XSetForeground(display,gc,white);
		}
	}

void deppx(int i, int dx)
	{
	sourcepnt[i].x+=dx;
	}

void deppy(int i, int dx)
	{
	sourcepnt[i].y+=dx;
	}

void deppz(int i, int dx)
	{
	sourcepnt[i].z+=dx;
	}

void deplacep(int dx, int dy, unsigned int state)
	{
		unsigned int	etat;
		int		i;

	nbnoeud=0;
	i=ind;
	etat=state&(Button1Mask|Button2Mask|Button3Mask);
	while((i!=-1)&&((i==ind)||(state&ShiftMask)))
		{
		switch (etat)	{
		case Button1Mask:
			deppx(i,dx);
			deppy(i,dy);
			break;
		case Button2Mask:
			deppx(i,dx);
			deppz(i,dy);
			break;
		case Button3Mask:
			deppz(i,dx);
			deppy(i,dy);
			break;
		default:
			break;	}
		i=sourcepnt[i].nxtp;
		}
	}


int merge()
	{
	char	name[128];
	FILE	*fichier;
	int	i;
	int	n1,n2,n3;
	int	nbpnt,nbpol;
	int	complex;

	printf("\nchargement d'un objet.\n>");
	scanf("%s",name);
	
	fichier=fopen(name,"r");
	if (fichier==NULL)	{
				printf("\nintrouvable\n");
				return 0;
				}

	fscanf(fichier,"%d",&nbpnt);  
	for(i=nbpntsource;i<nbpntsource+nbpnt;i++)
		{
		fscanf(fichier,"%f%f%f",&sourcepnt[i].x
			,&sourcepnt[i].y
			,&sourcepnt[i].z);
		empile(i);
		}

	fscanf(fichier,"%d",&nbpol);
	for(i=nbpolsource;i<nbpolsource+nbpol;i++)
		{
		fscanf(fichier,"%d%d%d%d",&sourcepol[i].type
			,&sourcepol[i].col,&sourcepol[i].ns
			,&sourcepol[i].frere);
		sourcepol[i].frere+=nbpolsource;

		if(sourcepol[i].ns==1)
			{
			fscanf(fichier,"%d%d",&n1,&n2);
			sourcepol[i].nums[0]=ajouteseg(nbpntsource+n1
							,nbpntsource+n2);
			}
		if(sourcepol[i].ns==3)
			{
			fscanf(fichier,"%d%d%d",&n1,&n2,&n3);
			sourcepol[i].nums[0]=ajouteseg(nbpntsource+n1
							,nbpntsource+n2);
			sourcepol[i].nums[1]=ajouteseg(nbpntsource+n2
							,nbpntsource+n3);
			sourcepol[i].nums[2]=ajouteseg(nbpntsource+n3
							,nbpntsource+n1);
			vnorm(&sourcepnt[nbpntsource+n1]
				,&sourcepnt[nbpntsource+n2]
				,&sourcepnt[nbpntsource+n3]
					,&sourcepol[i].norm);
			}
		}

	nbnoeud=0;
	if (nbpntsource==0)
	{
	fscanf(fichier,"%d",&nbnoeud);
	for(i=0;i<nbnoeud;i++)
		{
		fscanf(fichier,"%d%d%d%f%f%f%f"
			,&noeuds[i].firstp, &noeuds[i].filsp, &noeuds[i].filsm
			,&noeuds[i].a,&noeuds[i].b,&noeuds[i].c,&noeuds[i].d);
		if (noeuds[i].filsp!=-1) complex++;
		}
	}
	fclose(fichier);

	nbpntsource+=nbpnt;
	nbpolsource+=nbpol;

	printf("ok\n");

	return 1;

	}

int save()
	{
	char	name[128];
	FILE	*fichier;
	int	i,j,k;
	int	n1,n2,n3;

	afpara();

	printf("\nsauvegarde de l'objet.\n>");
	scanf("%s",name);
	
	fichier=fopen(name,"w");
	if (fichier==NULL)	{
				printf("\ni/o error\n");
				return 0;
				}

	fprintf(fichier,"%d\n",nbpntsource);  
	for(i=0;i<nbpntsource;i++)
		fprintf(fichier,"    %f  %f  %f\n",sourcepnt[i].x
			,sourcepnt[i].y
			,sourcepnt[i].z);

	fprintf(fichier,"%d\n",nbpolsource);
	for(i=0;i<nbpolsource;i++)
		{
		fprintf(fichier,"    %d  %d  %d  %d",sourcepol[i].type
			,sourcepol[i].col,sourcepol[i].ns
			,sourcepol[i].frere);

		if(sourcepol[i].ns==1)
			{
			k=sourcepol[i].nums[0]&0x7fff;
			fprintf(fichier,"  %d  %d"
				,sourceseg[k].n1,sourceseg[k].n2);
			}
		if(sourcepol[i].ns==3)
			for(j=0;j<sourcepol[i].ns;j++)
				{
				k=sourcepol[i].nums[j];
				if (k&0x8000)
					fprintf(fichier,"  %d"
						,sourceseg[k&0x7fff].n2);
					else
					fprintf(fichier,"  %d"
						,sourceseg[k].n1);
				}

		fprintf(fichier,"\n");
		}

	fprintf(fichier,"%d\n",nbnoeud);
	for(i=0;i<nbnoeud;i++)
		{
		fprintf(fichier,"    %d  %d  %d    %f  %f  %f  %f\n"
			,noeuds[i].firstp, noeuds[i].filsp, noeuds[i].filsm
			,noeuds[i].a,noeuds[i].b,noeuds[i].c,noeuds[i].d);
		}
	fclose(fichier);

	printf("ok\n");

	return 0;
	}

void chgcoord(unsigned int s)
	{
		float	xp,yp,zp;

	if (ind!=-1)
		{
		if (s) printf("\ndeplacement global");
		else	printf("\ndeplacement simple");
		printf("\nnouvelles coordonnees x y z\n> ");
		scanf("%f%f%f",&xp,&yp,&zp);
		deplacep(xp-sourcepnt[ind].x
				,yp-sourcepnt[ind].y
				,s|Button1Mask);
		deplacep(0,zp-sourcepnt[ind].z,s|Button2Mask);
		}
	}

void setcol()
	{
	col++;
	if (col==7) col=0;
	affichetools();
	}

void chgcol()
	{
		int	i,j,k;
		int	s;
		int	n[3];

	for(i=0;i<nbpolsource;i++)
		{
		for(j=0;j<3;j++)
			{
			k=sourcepol[i].nums[j];
			if (k&0x8000) n[j]=sourceseg[k&0x7fff].n2;
				else	n[j]=sourceseg[k].n1;
			}
		k=ind;
		s=0;
		while(k!=-1)
			{
			for(j=0;j<3;j++) if(n[j]==k) s++;
			k=sourcepnt[k].nxtp;
			}
		if (s==3) sourcepol[i].col=col;
		}
	}

void copyobj()
	{
		int	i;

	nbpnc=nbpntsource;
	for(i=0;i<nbpnc;i++)
		copypnt[i]=sourcepnt[i];

	nbsgc=nbsegsource;
	for(i=0;i<nbsgc;i++)
		copyseg[i]=sourceseg[i];

	nbplc=nbpolsource;
	for(i=0;i<nbplc;i++)
		copypol[i]=sourcepol[i];
	}

void recopyobj()
	{
		int	i;

	videpile();
	nbnoeud=0;

	nbpntsource=nbpnc;
	for(i=0;i<nbpnc;i++)
		sourcepnt[i]=copypnt[i];

	nbsegsource=nbsgc;
	for(i=0;i<nbsgc;i++)
		sourceseg[i]=copyseg[i];

	nbpolsource=nbplc;
	for(i=0;i<nbplc;i++)
		sourcepol[i]=copypol[i];
	}

int photo(observ obs, pass pb, Window win)
	{
	char	name[128];
	char	typ[128];
	FILE	*fphoto;
	int	i,k;
	float	del;
	int	modg;
	struct Vec vp;
	int	nbph;

	printf("\nsauvegarde de photo.\n>");
	scanf("%s",name);
	printf("serie de 3 photos (o/n)?");
	scanf("%s",typ);
	del=0;
	if (strcmp(typ,"o")) nbph=1;
		else
		{
		nbph=3;
		printf("distance entre les 3 cameras\n>");
		scanf("%f",&del);
		}

	fphoto=fopen(name,"w");
	if (fphoto==NULL)	{
				printf("\ni/o error\n");
				return 0;
				}
	fprintf(fphoto,"%d\n",nbph);

	modg=3;
	if (nbnoeud) modg=4;
	
	for(k=0;k<nbph;k++)
		{
		tmulmatvec(&pb->m, &pb->v, &vp);
		mulscalvec(-1.0, &vp, &vp);

		fprintf(fphoto,"  %f %f %f\n",vp.xv,vp.yv,vp.zv);
		fprintf(fphoto,"  %f %f %f\n",pb->m.aa,pb->m.ab,pb->m.ac);
		fprintf(fphoto,"  %f %f %f\n",pb->m.ba,pb->m.bb,pb->m.bc);
		fprintf(fphoto,"  %f %f %f\n",pb->m.ca,pb->m.cb,pb->m.cc);
		fprintf(fphoto,"  %f\n",obs->dist);

		XSetForeground(obs->display,obs->gc,black);
		XFlush(obs->display);
		XFillRectangle(obs->display,win,obs->gc
				,0,0,obs->sx*2,obs->sy*2);
		image3d(obs,pb,modg);
		XCopyArea(obs->display,obs->dessin,win,obs->gc
			,0,0,obs->sx*2,obs->sy*2,0,0);

		XFlush(obs->display);
		fprintf(fphoto,"%d\n",nbtrait);
		for(i=0;i<nbtrait;i++)
			fprintf(fphoto,"  %f  %f  %f  %f\n"
			,trait[i*4],trait[i*4+1],trait[i*4+2],trait[i*4+3]);
		if (k==0)    pb->v.xv-=del;
		if (k==1)  { pb->v.xv+=del/2; pb->v.yv-=del*0.866025; }
		if (k==2)  { pb->v.xv+=del/2; pb->v.yv+=del*0.866025; }
		sleep(1);
		fprintf(fphoto,"\n");
		}

	fclose(fphoto);
	printf("ok\n");
	}
